您的位置:首页 > 其它

LeetCode 004 Median of Two Sorted Arrays 二分 + 递归

2018-02-16 21:22 453 查看
There are two sorted arrays nums1 and nums2 of size m and n respectively.Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)).Example 1:
nums1 = [1, 3]
nums2 = [2]

The median is 2.0
Example 2:
nums1 = [1, 2]
nums2 = [3, 4]

The median is (2 + 3)/2 = 2.5解析:(来自discuss)In order to solve this question, we need to first understand what a median is. A median is the middle value of a dataset.
Since we have 2 seperately sorted array in this question, to find the middle value is somewhat complicated. However, keep in mind that we do not care about the actual value of the numbers, what we want is the middle point from the combination of 2 arrays. In other words, we are looking for the middle index of the 2 arrays. Thus approach like 
binary search
 could be employed.
Based on the fact that the 2 arrays are sorted seperatedly, we could try to get the submedian of the 2 arrays in each round. Than compare them. And the basic idea is that the left half of the array with a smaller submedian can never contains the common median.
if (mid1 < mid2) keep nums1.right + nums2
else keep nums1 + nums2.right
class Solution {
public double findMedianSortedArrays(int[] nums1, int[] nums2) {
int m = nums1.length, n = nums2.length;
int l = (m + n + 1) >> 1;
int r = (m + n + 2) >> 1;

return (getKth(nums1, 0, nums2, 0, l) + getKth(nums1, 0, nums2, 0, r)) / 2.0;
}

// 二分 + 递归 复杂度O(log(m + n))
// 这个函数查找nums1 + nums2的第k个元素,num1和num2的起始位置作为参数
private double getKth(int[] nums1, int start1, int[] nums2, int start2, int k) {
// 如果发现中位数不可能出现在某个数组中
if(start1 > nums1.length - 1) return nums2[start2 + k - 1];
if(start2 > nums2.length - 1) return nums1[start1 + k - 1];

if(k == 1) return Math.min(nums1[start1], nums2[start2]);

int mid1 = Integer.MAX_VALUE;
int mid2 = Integer.MAX_VALUE;

if(start1 + k / 2 - 1 < nums1.length) mid1 = nums1[start1 + k / 2 - 1];
if(start2 + k / 2 - 1 < nums2.length) mid2 = nums2[start2 + k / 2 - 1];

// 去除其中一个数组的一半,其中k也要减半
if(mid1 < mid2) {
return getKth(nums1, start1 + k / 2, nums2, start2, k - k / 2);
} else {
return getKth(nums1, start1, nums2, start2 + k / 2, k - k / 2);
}
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: